#!/bin/bash
#
# whichip.sub generator
#  Gets latest gix data from latnet and builds which.sub to later use
#  from count.pl
#
# Romans, Aug 1999
#
# >=0 - lv trafic, <0 = foreign
#  
#

[ -f whichip.sub~ ] && mv -f whichip.sub~{,~}
[ -f whichip.sub ] && mv -f whichip.sub{,~}
echo -e 'sub whichip {\n($ar)=@_;\n($i1,$i2,$i3,$i4)=split(/\./,$ar);\n$ip=((($i1<<8)+$i2<<8)+$i3<<8)+$i4;' > whichip.sub
cat ourip | \
 awk '
   {
    x=substr($2,2,length($2)-2);
    split(x,nm,/\./);
    split($1,ip,/\./);
    print "return 2 if (($ip & (((" nm[1] "<<8)+" nm[2] "<<8)+" \
     nm[3] "<<8)+" nm[4]") == (((" ip[1] "<<8)+" ip[2] "<<8)+" \
     ip[3] "<<8)+" ip[4]");"
   }' >> whichip.sub

lynx http://www.nic.lv/gix.html -dump | \
 sed '
  s/\[[0-9]*\]//g;
  s/^ *//g;
  s|/[0-9]*||g' | \
 egrep '^[0-9]+\.[0-9]+\.' | \
 awk '
   {
    x=substr($2,2,length($2)-2);
    split(x,nm,/\./);
    split($1,ip,/\./);
    print "return 0 if (($ip & (((" nm[1] "<<8)+" nm[2] "<<8)+" \
     nm[3] "<<8)+" nm[4]") == (((" ip[1] "<<8)+" ip[2] "<<8)+" \
     ip[3] "<<8)+" ip[4]");"
   }' >> whichip.sub
echo -e "return -1;\n}" >> whichip.sub
if [ -f whichip.sub~ ]; then
 cmp whichip.sub{,~} >/dev/null 2>&1 || {
  echo "- diff whichip.sub~ whichip.sub -"
  diff whichip.sub~ whichip.sub
  exit 0
 }
 rm -f whichip.sub~
fi
[ -f whichip.sub~~ ] && mv whichip.sub~{~,}
exit 0
